## srsgui-2.0-4.src.tar.gz

=== CMakeLists.txt ===
# Copyright 2012-2013 The srsGUI Project Developers. See the
# COPYRIGHT file at the top-level directory of this distribution.
#
# This file is part of the srsGUI Project.
#
# srsGUI is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation, either version 3 of
# the License, or (at your option) any later version.
#
# srsGUI is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# A copy of the GNU Lesser General Public License can be found in
# the LICENSE file in the top-level directory of this distribution
# and at http://www.gnu.org/licenses/.
#

########################################################################
# Prevent in-tree builds
########################################################################
IF(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
    MESSAGE(FATAL_ERROR "Prevented in-tree build. This is bad practice.")
ENDIF(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})

########################################################################
# Project setup
########################################################################
CMAKE_MINIMUM_REQUIRED (VERSION 2.6)
PROJECT (srsGUI)
ENABLE_TESTING()
LIST(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/modules")
INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/include)

########################################################################
# Install Dirs
########################################################################
if (NOT CMAKE_INSTALL_LIBDIR)
  include(GNUInstallDirs)
endif (NOT CMAKE_INSTALL_LIBDIR)
  
# Fall back to just "lib" if the item provided by GNUInstallDirs doesn't exist
# For example, on Ubuntu 13.10 with CMake 2.8.11.2,
# /usr/lib/${CMAKE_LIBRARY_ARCHITECTURE} doesn't exist.
if (NOT EXISTS "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
  message(STATUS "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR} does not exist. Defaulting install location to ${CMAKE_INSTALL_PREFIX}/lib.")
  set(CMAKE_INSTALL_LIBDIR lib)
endif()

SET(RUNTIME_DIR bin)
SET(LIBRARY_DIR ${CMAKE_INSTALL_LIBDIR})
SET(INCLUDE_DIR include)

########################################################################
# Setup Boost
########################################################################
MESSAGE(STATUS "")
MESSAGE(STATUS "Configuring Boost C++ Libraries...")
SET(BOOST_REQUIRED_COMPONENTS
    thread
    unit_test_framework
    system
)

IF(UNIX AND EXISTS "/usr/lib64")
    LIST(APPEND BOOST_LIBRARYDIR "/usr/lib64") #fedora 64-bit fix
ENDIF(UNIX AND EXISTS "/usr/lib64")

IF(MSVC)
    SET(BOOST_ALL_DYN_LINK "${BOOST_ALL_DYN_LINK}" CACHE BOOL "boost enable dynamic linking")
    IF(BOOST_ALL_DYN_LINK)
        ADD_DEFINITIONS(-DBOOST_ALL_DYN_LINK) #setup boost auto-linking in msvc
    ELSE(BOOST_ALL_DYN_LINK)
        UNSET(BOOST_REQUIRED_COMPONENTS) #empty components list for static link
    ENDIF(BOOST_ALL_DYN_LINK)
ENDIF(MSVC)

SET(Boost_ADDITIONAL_VERSIONS
    "1.37.0" "1.37" "1.38.0" "1.38" "1.39.0" "1.39" "1.40.0" "1.40"
    "1.41.0" "1.41" "1.42.0" "1.42" "1.43.0" "1.43" "1.44.0" "1.44"
    "1.42.0" "1.42" "1.43.0" "1.43" "1.44.0" "1.44" "1.45.0" "1.45"
    "1.46.0" "1.46" "1.47.0" "1.47" "1.48.0" "1.48" "1.49.0" "1.49"
    "1.50.0" "1.50" "1.51.0" "1.51" "1.52.0" "1.52" "1.53.0" "1.53")
FIND_PACKAGE(Boost 1.37 REQUIRED ${BOOST_REQUIRED_COMPONENTS})
MESSAGE(STATUS "Boost version: ${Boost_VERSION}")

IF(Boost_VERSION LESS 104600)
    ADD_DEFINITIONS( -DBOOST_FILESYSTEM_VERSION=2 ) #use filesystem version 2 in boost < 1.46
    MESSAGE(STATUS "Using Boost Filesystem V2")
ENDIF(Boost_VERSION LESS 104600)

INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIRS})
LINK_DIRECTORIES(${Boost_LIBRARY_DIRS})

MESSAGE(STATUS "Boost include directories: ${Boost_INCLUDE_DIRS}")
MESSAGE(STATUS "Boost library directories: ${Boost_LIBRARY_DIRS}")
MESSAGE(STATUS "Boost libraries: ${Boost_LIBRARIES}")

########################################################################
# Macro to add -fPIC property to static libs 
########################################################################
MACRO(SG_SET_PIC)
	IF( CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64" )
        SET_TARGET_PROPERTIES(${ARGV} PROPERTIES COMPILE_FLAGS -fPIC)
    ENDIF( CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64" )
ENDMACRO(SG_SET_PIC)

########################################################################
# Add the subdirectories
########################################################################
ADD_SUBDIRECTORY(include)
ADD_SUBDIRECTORY(src)
ADD_SUBDIRECTORY(test)

=== include/CMakeLists.txt ===
########################################################################
# Install headers
########################################################################
INSTALL(DIRECTORY srsgui
        DESTINATION "${INCLUDE_DIR}"
        FILES_MATCHING PATTERN "*.h"
        PATTERN ".svn" EXCLUDE
)

########################################################################
# Add headers to cmake project (useful for IDEs)
########################################################################
SET(HEADERS_ALL "")
FILE(GLOB headers *)
FOREACH (_header ${headers})
        IF(IS_DIRECTORY ${_header})
                FILE(GLOB_RECURSE tmp "${_header}/*.h")
                LIST(APPEND HEADERS_ALL ${tmp})
        ENDIF(IS_DIRECTORY ${_header})
ENDFOREACH()
ADD_CUSTOM_TARGET (add_srsgui_headers SOURCES ${HEADERS_ALL})

=== src/CMakeLists.txt ===
########################################################################
# Setup Qt and Qwt
########################################################################

find_package(Qt5 COMPONENTS Widgets REQUIRED)

FIND_PACKAGE(Qwt)
IF(Qt5_FOUND AND QWT_FOUND)
    INCLUDE_DIRECTORIES(${QWT_INCLUDE_DIRS})
ENDIF(Qt5_FOUND AND QWT_FOUND)
 
########################################################################
# Build the graphics library
########################################################################

file(GLOB modules *) 

SET(SOURCES_ALL "")
FILE(GLOB tmp "*.cpp")
LIST(APPEND SOURCES_ALL ${tmp})
FOREACH (_module ${modules})
	IF(IS_DIRECTORY ${_module})
		FILE(GLOB tmp "${_module}/*.cpp")
		LIST(APPEND SOURCES_ALL ${tmp})		
	ENDIF(IS_DIRECTORY ${_module})
ENDFOREACH(_module ${modules})

IF(QWT_MAJOR_VERSION LESS 6)
	MESSAGE(STATUS "QWT6 is required.")
ENDIF(QWT_MAJOR_VERSION LESS 6)

IF(Qt5_FOUND AND QWT_FOUND AND QWT_MAJOR_VERSION EQUAL 6)
  QT5_WRAP_CPP(lineplotwraps ../include/srsgui/common/Lineplot.h)
  QT5_WRAP_CPP(pointplotwraps ../include/srsgui/common/Pointplot.h)
  QT5_WRAP_CPP(spectrogramplotwraps ../include/srsgui/common/Spectrogramplot.h)
  QT5_WRAP_CPP(complex complexplot/ComplexWidget.h complexplot/ComplexplotWrapper.h)
  QT5_WRAP_CPP(real realplot/RealWidget.h realplot/RealplotWrapper.h)
  QT5_WRAP_CPP(scatter scatterplot/ScatterWidget.h scatterplot/ScatterplotWrapper.h)
  QT5_WRAP_CPP(waterfall waterfallplot/WaterfallWidget.h waterfallplot/WaterfallplotWrapper.h)
  QT5_WRAP_CPP(textedit textedit/TextEditWidget.h textedit/TextEditWrapper.h)
  QT5_WRAP_CPP(keyvalue keyvalue/KeyValueWidget.h keyvalue/KeyValueWrapper.h)

  INCLUDE_DIRECTORIES(common complexplot realplot scatterplot waterfallplot textedit keyvalue ${Boost_INCLUDE_DIRS})
  
  ADD_LIBRARY(srsgui SHARED ${eventwraps} ${lineplotwraps} ${pointplotwraps} ${spectrogramplotwraps} ${complex} ${real} ${scatter} ${waterfall} ${textedit} ${keyvalue} ${SOURCES_ALL} )
  TARGET_LINK_LIBRARIES(srsgui pthread Qt5::Widgets ${QWT_LIBRARIES})
  INSTALL(TARGETS srsgui DESTINATION ${LIBRARY_DIR})
  SG_SET_PIC(srsgui)

  MESSAGE(STATUS "   srsGUI library will be installed.")

ELSE(Qt5_FOUND AND QWT_FOUND AND AND QWT_MAJOR_VERSION EQUAL 6) 

  MESSAGE(STATUS "   QT5 or Qwt6 not found. srsGUI library is not generated")
  
ENDIF(Qt5_FOUND AND QWT_FOUND AND QWT_MAJOR_VERSION EQUAL 6)

=== test/CMakeLists.txt ===
#
# Copyright 2012-2013 The srsGUI Project Developers. See the
# COPYRIGHT file at the top-level directory of this distribution.
#
# This file is part of the srsGUI Project.
#
# srsGUI is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation, either version 3 of
# the License, or (at your option) any later version.
#
# srsGUI is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# A copy of the GNU Lesser General Public License can be found in
# the LICENSE file in the top-level directory of this distribution
# and at http://www.gnu.org/licenses/.
#

########################################################################
# Add the subdirectories
########################################################################
ADD_SUBDIRECTORY(c)
ADD_SUBDIRECTORY(cxx)

=== src/common/CMakeLists.txt ===
########################################################################
# Setup Qt and Qwt
########################################################################
FIND_PACKAGE(Qwt)
IF(Qt5_FOUND AND QWT_FOUND)
    INCLUDE_DIRECTORIES(${QWT_INCLUDE_DIRS})
ENDIF(Qt5_FOUND AND QWT_FOUND)
 
########################################################################
# Build our libraries
########################################################################
IF(Qt5_FOUND AND QWT_FOUND)
  QT5_WRAP_CPP(eventwraps Events.h)
  ADD_LIBRARY(events Events.cpp ${eventwraps})
  TARGET_LINK_LIBRARIES(events Qt5::Widgets ${QWT_LIBRARIES})
  SG_SET_PIC(events)
  QT5_WRAP_CPP(lineplotwraps Lineplot.h)
  ADD_LIBRARY(lineplot Lineplot.cpp ${lineplotwraps})
  TARGET_LINK_LIBRARIES(lineplot Qt5::Widgets ${QWT_LIBRARIES} events)
  SG_SET_PIC(lineplot)
  QT5_WRAP_CPP(pointplotwraps Pointplot.h)
  ADD_LIBRARY(pointplot Pointplot.cpp ${pointplotwraps})
  TARGET_LINK_LIBRARIES(pointplot Qt5::Widgets ${QWT_LIBRARIES} events)
  SG_SET_PIC(pointplot)
  QT5_WRAP_CPP(spectrogramplotwraps Spectrogramplot.h)
  ADD_LIBRARY(spectrogramplot Spectrogramplot.cpp ${spectrogramplotwraps})
  TARGET_LINK_LIBRARIES(spectrogramplot Qt5::Widgets ${QWT_LIBRARIES} events)
  SG_SET_PIC(spectrogramplot)
ENDIF(Qt5_FOUND AND QWT_FOUND)

=== src/complexplot/CMakeLists.txt ===
########################################################################
# Setup Qt and Qwt
########################################################################
FIND_PACKAGE(Qwt)
IF(Qt5_FOUND AND QWT_FOUND)
    INCLUDE_DIRECTORIES(${QWT_INCLUDE_DIRS})
ENDIF(Qt5_FOUND AND QWT_FOUND)
 
########################################################################
# Build our library
########################################################################
IF(Qt5_FOUND AND QWT_FOUND)
  QT5_WRAP_CPP(MOCSrcs ComplexWidget.h ComplexplotWrapper.h)
  ADD_LIBRARY(complexplot ComplexWidget.cpp ComplexplotWrapper.cpp Complexplot.cpp ${MOCSrcs})
  TARGET_LINK_LIBRARIES(complexplot Qt5::Widgets ${QWT_LIBRARIES} lineplot)
  SG_SET_PIC(complexplot)
  SET(SG_HAVE_COMPLEXPLOT ON CACHE INTERNAL "Has Complexplot been built?")
  ADD_SUBDIRECTORY(test)
ELSE(Qt5_FOUND AND QWT_FOUND)
  SET(SG_HAVE_COMPLEXPLOT OFF CACHE INTERNAL "Has Complexplot been built?")
ENDIF(Qt5_FOUND AND QWT_FOUND)

=== src/keyvalue/CMakeLists.txt ===
########################################################################
# Setup Qt and Qwt
########################################################################
FIND_PACKAGE(Qwt)
IF(Qt5_FOUND AND QWT_FOUND)
    INCLUDE_DIRECTORIES(${QWT_INCLUDE_DIRS})
ENDIF(Qt5_FOUND AND QWT_FOUND)

########################################################################
# Build our library
########################################################################
IF(Qt5_FOUND AND QWT_FOUND)
  QT5_WRAP_CPP(MOCSrcs KeyValueWidget.h KeyValueWrapper.h)
  ADD_LIBRARY(keyvalue KeyValueWidget.cpp KeyValueWrapper.cpp KeyValue.cpp ${MOCSrcs})
  TARGET_LINK_LIBRARIES(keyvalue Qt5::Widgets ${QWT_LIBRARIES})
  SG_SET_PIC(keyvalue)
  SET(SG_HAVE_KEYVALUE ON CACHE INTERNAL "Has KeyValue been built?")
  #ADD_SUBDIRECTORY(test)
ELSE(Qt5_FOUND AND QWT_FOUND)
  SET(SG_HAVE_KEYVALUE OFF CACHE INTERNAL "Has KeyValue been built?")
ENDIF(Qt5_FOUND AND QWT_FOUND)

=== src/realplot/CMakeLists.txt ===
########################################################################
# Setup Qt and Qwt
########################################################################
FIND_PACKAGE(Qwt)
IF(Qt5_FOUND AND QWT_FOUND)
    INCLUDE_DIRECTORIES(${QWT_INCLUDE_DIRS})
ENDIF(Qt5_FOUND AND QWT_FOUND)
 
########################################################################
# Build our library
########################################################################
IF(Qt5_FOUND AND QWT_FOUND)
  QT5_WRAP_CPP(MOCSrcs RealWidget.h RealplotWrapper.h)
  ADD_LIBRARY(realplot RealWidget.cpp RealplotWrapper.cpp Realplot.cpp ${MOCSrcs})
  TARGET_LINK_LIBRARIES(realplot Qt5::Widgets ${QWT_LIBRARIES} lineplot)
  SG_SET_PIC(realplot)
  SET(SG_HAVE_REALPLOT ON CACHE INTERNAL "Has Realplot been built?")
  ADD_SUBDIRECTORY(test)
ELSE(Qt5_FOUND AND QWT_FOUND)
  SET(SG_HAVE_REALPLOT OFF CACHE INTERNAL "Has Realplot been built?")
ENDIF(Qt5_FOUND AND QWT_FOUND)

=== src/scatterplot/CMakeLists.txt ===
########################################################################
# Setup Qt and Qwt
########################################################################
FIND_PACKAGE(Qwt)
IF(Qt5_FOUND AND QWT_FOUND)
    INCLUDE_DIRECTORIES(${QWT_INCLUDE_DIRS})
ENDIF(Qt5_FOUND AND QWT_FOUND)
 
########################################################################
# Build our library
########################################################################
IF(Qt5_FOUND AND QWT_FOUND)
  QT5_WRAP_CPP(MOCSrcs ScatterWidget.h ScatterplotWrapper.h)
  ADD_LIBRARY(scatterplot ScatterWidget.cpp ScatterplotWrapper.cpp Scatterplot.cpp ${MOCSrcs})
  TARGET_LINK_LIBRARIES(scatterplot Qt5::Widgets ${QWT_LIBRARIES} pointplot)
  SG_SET_PIC(scatterplot)
  SET(SG_HAVE_SCATTERPLOT ON CACHE INTERNAL "Has Scatterplot been built?")
  ADD_SUBDIRECTORY(test)
ELSE(Qt5_FOUND AND QWT_FOUND)
  SET(SG_HAVE_SCATTERPLOT OFF CACHE INTERNAL "Has Scatterplot been built?")
ENDIF(Qt5_FOUND AND QWT_FOUND)

=== src/textedit/CMakeLists.txt ===
########################################################################
# Setup Qt and Qwt
########################################################################
FIND_PACKAGE(Qwt)
IF(Qt5_FOUND AND QWT_FOUND)
    INCLUDE_DIRECTORIES(${QWT_INCLUDE_DIRS})
ENDIF(Qt5_FOUND AND QWT_FOUND)

########################################################################
# Build our library
########################################################################
IF(Qt5_FOUND AND QWT_FOUND)
  QT5_WRAP_CPP(MOCSrcs TextEditWidget.h TextEditWrapper.h)
  ADD_LIBRARY(textedit TextEditWidget.cpp TextEditWrapper.cpp TextEdit.cpp ${MOCSrcs})
  TARGET_LINK_LIBRARIES(textedit Qt5::Widgets ${QWT_LIBRARIES})
  SG_SET_PIC(textedit)
  SET(SG_HAVE_TEXTEDIT ON CACHE INTERNAL "Has Textedit been built?")
  #ADD_SUBDIRECTORY(test)
ELSE(Qt5_FOUND AND QWT_FOUND)
  SET(SG_HAVE_TEXTEDIT OFF CACHE INTERNAL "Has Textedit been built?")
ENDIF(Qt5_FOUND AND QWT_FOUND)

=== src/waterfallplot/CMakeLists.txt ===
########################################################################
# Setup Qt and Qwt
########################################################################
FIND_PACKAGE(Qwt)
IF(Qt5_FOUND AND QWT_FOUND)
    INCLUDE_DIRECTORIES(${QWT_INCLUDE_DIRS})
ENDIF(Qt5_FOUND AND QWT_FOUND)
 
########################################################################
# Build our library
########################################################################
IF(Qt5_FOUND AND QWT_FOUND)
  QT5_WRAP_CPP(MOCSrcs WaterfallWidget.h WaterfallplotWrapper.h)
  ADD_LIBRARY(waterfallplot WaterfallWidget.cpp WaterfallplotWrapper.cpp Waterfallplot.cpp ${MOCSrcs})
  TARGET_LINK_LIBRARIES(waterfallplot Qt5::Widgets ${QWT_LIBRARIES} lineplot spectrogramplot)
  SG_SET_PIC(waterfallplot)
  SET(SG_HAVE_WATERFALLPLOT ON CACHE INTERNAL "Has Waterfallplot been built?")
  ADD_SUBDIRECTORY(test)
ELSE(Qt5_FOUND AND QWT_FOUND)
  SET(SG_HAVE_WATERFALLPLOT OFF CACHE INTERNAL "Has Waterfallplot been built?")
ENDIF(Qt5_FOUND AND QWT_FOUND)

=== test/c/CMakeLists.txt ===
########################################################################
# Build tests
########################################################################

ADD_EXECUTABLE(waterfallplot_test_c waterfallplot_test.c)
TARGET_LINK_LIBRARIES(waterfallplot_test_c srsgui m)
ADD_TEST(waterfallplot_test_c waterfallplot_test_c)

ADD_EXECUTABLE(complexplot_test_c complexplot_test.c)
TARGET_LINK_LIBRARIES(complexplot_test_c srsgui m)
ADD_TEST(complexplot_test_c complexplot_test_c)

ADD_EXECUTABLE(realplot_test_c realplot_test.c)
TARGET_LINK_LIBRARIES(realplot_test_c srsgui m)
ADD_TEST(realplot_test_c realplot_test_c)

ADD_EXECUTABLE(scatterplot_test_c scatterplot_test.c)
TARGET_LINK_LIBRARIES(scatterplot_test_c srsgui m)
ADD_TEST(scatterplot_test_c scatterplot_test_c)

=== PKGBUILD ===
# Maintainer: Filipe Laíns (FFY00) <lains@archlinux.org>

pkgname=srsgui
_pkgname=srsGUI
pkgver=2.0
_tag=release_${pkgver/./_}_qt5
pkgrel=4
pkgdesc='A graphics library for software radio'
arch=('x86_64')
url='https://github.com/srsLTE/srsGUI'
license=('AGPL3')
depends=('qt5-base' 'qwt')
makedepends=('cmake' 'boost')
source=("$_pkgname-$pkgver.tar.gz::$url/archive/$_tag.tar.gz"
         srsgui-qwt-6.2.patch
         boost-1.83.patch)
sha512sums=('9d766a80fc81b015f5c8dbed3fa97d417496a0e4db11bd23a66bae4c3a2d7e0206f2569af8884d01b40702416dab6add52cc0ef04f29b176aba99de00466a88d'
            '1097681e57d0548db36db9ab1331e6e96554b44618b21ee08631e188e092796d57ec49c0456055b633026246eb652f75cd7470c60bb530ebf246d92cd9f28b5e'
            'fb01776c9477b0c7f0fc3e983585500512f0c87a8f0d2df6732cf7c0d2e67a7f50b21e75b6e2ca78e40723a8683463139c627174171815e44ce1172cdaa50503')

prepare() {
  patch -d $_pkgname-$_tag -p1 < srsgui-qwt-6.2.patch # Fix build with qwt 6.2
  patch -d $_pkgname-$_tag -p1 < boost-1.83.patch # Fix build with boost 1.83
}

build() {
  mkdir $_pkgname-$_tag/build
  cd $_pkgname-$_tag/build

  cmake .. \
    -DCMAKE_INSTALL_PREFIX=/usr \
    -DCMAKE_BUILD_TYPE=Release \
    -DQWT_NAMES=qwt

  make
}

package() {
  cd $_pkgname-$_tag/build

  make DESTDIR="$pkgdir" install
}
